/* Copyright (C) 2013 by Daniel Stenberg et al
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

#include "test_utils.h"
#include <string.h>
#include <stdlib.h>

static unsigned char hex2int(char hex)
  {
    if (hex >= 'a' && hex <= 'f') {
        return hex - 'a' + 10;
    } else if (hex >= 'A' && hex <= 'F') {
        return hex - 'A' + 10;
    } else {
        return hex - '0';
    }
  }

struct frame hex2frame(const char *hex)
  {
    size_t hex_len = strlen(hex);
    struct frame ret = { malloc(hex_len/2), hex_len/2 };
    size_t i;
    for (i=0; i< hex_len/2; ++i)
      {
        ret.abuf[i] = (hex2int(hex[i * 2]) << 4) | hex2int(hex[i * 2 + 1]);
      }
    return ret;
  }

void free_frame(struct frame value)
  {
    free(value.abuf);
  }
